#include "CivHydrFuncInter.h"
#include "CivHydrCalc.h"
#include "CivSysLog.h"

#include "CivPgConn.h"
#include "CivHydrSimulation.h"

bool DLLEXPORT simulation(char* uri, char* netName, char* flag)
{

    char fileName[256];
    char rptR[256];
    char outBinFile[256];

    strcpy_s(fileName, "test.inp");
    strcpy_s(rptR, "test.rpt");
    strcpy_s(outBinFile, "test.bin");

    CivHydrCalc* calc = new CivHydrCalc(uri, netName);
    CivSysLog::getInstance()->info("ʼ", "interface", __FUNCTION__);
    bool msg = false;
    if (strcmp(flag,"HDY")==0)
        msg = calc->hydrSimulation( fileName, rptR, outBinFile);
    else if(strcmp(flag, "QUALITY")==0)
        msg = calc->qualitySimulation(fileName, rptR, outBinFile);

    if (msg)
    {
        CivSysLog::getInstance()->info("ɹ", "interface", __FUNCTION__);
    }       
    else
    {
        CivSysLog::getInstance()->info("ʧ", "interface", __FUNCTION__);
    }
    delete calc;
    return msg;
}


bool DLLEXPORT hdySimulation(char* uri, char* netName)
{
    return true;
}

bool DLLEXPORT getDataByInterval(char* uri, char* date, char* interval)
{
    CivDbConn* dbConn = new CivPgConn(uri);
    if (!dbConn->open())
    {
        delete dbConn;
        return false;
    }
       
    if (!dbConn->updateNodeByInterval(date, interval))
    {
        delete dbConn;
        return false;
    }
       
    if (!dbConn->updateLinkByInterval(date, interval))
    {
        delete dbConn;
        return false;
    }

    return true;
}


bool DLLEXPORT hdyrSimulation(char* uri)
{
    // ݿ
    CivDbConn* pgConn = new CivPgConn(uri);

    // ģ
    CivHydrSimulation* mHyDr = new CivHydrSimulation(pgConn);
   
    //ʼģ
    int flag = mHyDr->hdyrSimulation();

    delete mHyDr;
    delete pgConn;
   
    return flag;
}

bool DLLEXPORT qualitySimulation(char* uri)
{
    // ݿ
    CivDbConn* pgConn = new CivPgConn(uri);

    // ģ
    CivHydrSimulation* mHyDr = new CivHydrSimulation();
    mHyDr->registDb(pgConn);

    //ʼģ
    int flag = mHyDr->qualitySimulation();

    delete pgConn;
    delete mHyDr;

    return flag;
}

bool  DLLEXPORT   trackingSimulation(char* uri, char* sN, int hours, char* result)
{

    // ݿ
    CivDbConn* pgConn = new CivPgConn(uri);

    // ģ
    CivHydrSimulation* mHyDr = new CivHydrSimulation();
    mHyDr->registDb(pgConn);

    //ʼģ
    bool flag = mHyDr->trackingSimulation(sN, hours);
    std::string strResult;

    if (flag)
    {       
        mHyDr->getTrackingResult(hours, strResult);     
        strcpy(result, strResult.c_str());
    }
  
    delete pgConn;
    delete mHyDr;

    return  flag;
}